/* File: $Id: main.cc,v 1.19 1998/02/25 16:17:56 morsiani Exp $ */

/****************************************************************************
 *
 * This module contains the main() startup function for MPS simulator.  
 *
 * It creates a XInterface object (passing the line arguments to it), shows
 * the simulator main window, and calls the interface main loop function.
 *
 ****************************************************************************/


/****************************************************************************/
/* Inclusion of header files.                                               */
/****************************************************************************/

#include "forms.h"

#include "h/const.h"
#include "h/types.h"


/****************************************************************************/
/* Inclusion of imported declarations.                                      */
/****************************************************************************/

#include "e/xinterface.e"


/****************************************************************************/
/* Declarations strictly local to the module.                               */
/****************************************************************************/


/****************************************************************************/
/* Definitions to be exported.                                              */
/****************************************************************************/

int main(int argc, char * argv[])
{
	XInterface * xint = new XInterface(&argc, argv);
	
	xint->ShowMainForm();	
	
	xint->MainLoop();
	
	// should never exit here, since XInterface should intercept all
	// normal exit requests from user
	delete xint;
	fl_finish();
	return(EXIT_FAILURE);
}

			
/****************************************************************************/
/* Definitions strictly local to the module.                                */
/****************************************************************************/

