 #$Id: tapeboot.s,v 1.3 1998/02/23 15:46:18 morsiani Exp $

	.abicalls

 # GCC automatic generated header
 
 # GNU C 2.7.2 [AL 1.1, MM 40] Linux/MIPSEL compiled by GNU C

 # Cc1 defaults:
 # -mgas -mabicalls

 # Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
 # -quiet -dumpbase -version -o
 # 

 	# Constants

	STATUSMASK 	= 0xFFBFFFF3
	BIOSVECTPAGE 	= 0xC0000000
	BIOSVECTFRAME 	= 0x20000000
	DVGPERMISSION 	= 0x700
	BIOSPANIC	= 0x80000088
	VECTAREANUM	= 8
	VECTPCPOS	= 132
	VECTSIZE	= 136
	KCONTEXTOFFS	= 0x500
	KPTABVPAGE	= 0xC0001000
	KPTABFRAME	= 0x20001000
	CONTEXTSTART	= 21
	PROGVSTART	= 0x00400004

	TERM0COMMAND	= 0xB000015C
	BYTELEN 	= 8
	PRINTCHR	= 2	
	DOTCHAR		= 46
	LFCHAR		= 10
	
	TAPE0BASE	= 0xB0000090
	TAPESTART	= 3
	READBLK		= 3
	
	ACK		= 1
	BUSYCODE	= 3
	READYCODE	= 1
	EOBCODE		= 2

	RAMBASE		= 0x20000000
	BLOCKSIZE	= 512

	PADDINGTLB	= 0x100 - 8
	PADDINGEXC	= 0x80 - 16

	#Code start

	.text
	.align	2
	.globl	tapeboot
	.type	tapeboot,@function
	.ent	tapeboot

tapeboot:
	.frame	$fp,0,$31
	.mask	0x00000000,0
	.fmask	0x00000000,0
	.set noat

	.set noreorder
	.set nomacro

	# boot starts here 
	j LTapeBootStart
	nop

	.space PADDINGTLB

	# TLB miss should not happen during boot phase: jumps to BIOS PANIC
	lui	$26, 0x8000
	ori	$26, $26, 0x88
	jr	$26
	nop

	.space PADDINGEXC

	# no other exceptions should happen during boot phase:
	# jumps to BIOS PANIC
	lui	$26, 0x8000
	ori	$26, $26, 0x88
	jr	$26
	nop	

	.set reorder
	.set macro

LTapeBootStart:	
	# mapping all exception vectors to BIOS code
	# this is done resetting bit 22 in STATUS CP0 register
	# we also assure that kernel will start in kernel mode, with
	# interrupts disabled: this is done setting to 0 bits 3 and 2
	mfc0	$4, $12
	li	$5, STATUSMASK   
	and	$4, $4, $5
	mtc0	$4, $12
	
	# loads the kernel from tape: for each block loaded a dot will be
	# printed on terminal 0 

	# initializations	

	li 	$2, TAPE0BASE
	li 	$3, TAPESTART
	lw	$4, +12($2)
	
	# if tape is not loaded from start, BIOS panic() routine is called
	beq	$3, $4, LStartLoad
	
	li	$26, BIOSPANIC
	jr	$26

LStartLoad:	

	# else loading may start

	# physical memory load index
	li	$26, RAMBASE - BLOCKSIZE
	
	# tape READBLK command
	li	$27, READBLK

	# terminal 0 COMMAND address and busy code
	li 	$7, TERM0COMMAND
	li 	$8, BUSYCODE

	# tape loading main loop 

LTapeLoadLoop:
	# stores physical loading address into TAPE0 DATA0 register
	# and starts read operation

	addi 	$26, BLOCKSIZE

	sw 	$26, +8($2)
	sw 	$27, +4($2)
	
	li	$3, BUSYCODE

LTapeWaitLoop:
	#loads STATUS register
	lw	$4, +0($2)
	beq	$3, $4, LTapeWaitLoop

	# tape STATUS ($4) is no more BUSY: looking for errors
	li 	$3, READYCODE

	beq	$4, $3, LContinueLoad

	li	$26, BIOSPANIC
	jr	$26

LContinueLoad:
	# all ok

LPrintDotWaitLoop:

	# awaits terminal 0 availability

	lw 	$6, -4($7)
	beq	$6, $8, LPrintDotWaitLoop
	
	#load ASCII value of '.' into register 
	li	$5, DOTCHAR

	#prepares PRINTCHAR command
	sll 	$5, BYTELEN
	addi	$5, PRINTCHR
	sw	$5, 0($7)


	# examines tape DATA1 register to see if next block must be read:
	# load ends when an EOF or EOT is found, thus it continues when
	# an EOB is found

	lw 	$4, +12($2)
	li	$3, EOBCODE

	beq	$3, $4, LTapeLoadLoop

	#tape load ends here: clearing tape interrupt

	li 	$27, ACK	
	sw	$27, +4($2)


LPrintLFWaitLoop:

	# awaits terminal 0 availability

	lw 	$6, -4($7)
	beq	$6, $8, LPrintLFWaitLoop
	
	#load ASCII value of LF into register 
	li	$5, LFCHAR

	#prepares PRINTCHAR command
	sll 	$5, BYTELEN
	addi	$5, PRINTCHR
	sw	$5, 0($7)

	# awaits terminal 0 availability again

LPrintLoop2:
	lw 	$6, -4($7)
	beq	$6, $8, LPrintLoop2

	# clears pending interrupt on terminal 0

	li	$5, ACK
	sw	$5, 0($7)

	# setting boot exception vectors into first page of RAM memory:
 	# at first, all exceptions cause a kernel panic()

	#at first, load into TLB entry 0 page frame position
	li 	$4, BIOSVECTPAGE
	mtc0	$4, $10
	li	$4, (BIOSVECTFRAME | DVGPERMISSION)
	mtc0	$4, $2
	# load INDEX CP0 reg with 0
	mtc0	$0, $0
	
	# this is needed since assembler dos not see data dependency 
	# between mtc0 and tlb operations
	.set noreorder
	.set nomacro
	nop
	tlbwi	
	nop
	.set reorder
	.set macro

	# then, load kernel panic() BIOS routine address into every PC field
	# of exception vectors

	# there are: 1 vector for interrupt, 1 for TLB memory management, 
	# 1 for syscall and break (passup from BIOS), 1 for program traps
	# (all remaining exceptions)
	# total: 4 vectors; 
	# each contains two areas: old and new; fill both PCs at start

	# every vector area contains:  29 words for GPR ($0, k0 & k1 are 
	# excluded), 2 for HI & LO regs, 1 for STATUS CP0 reg, 1 for
	# ASID & CONTEXT (since fields don't overlap, they fit in 1 word)
	# 1 for EPC (old area) or PC (new area)
	# total: 34 words of memory per area
	
	li 	$4, BIOSVECTPAGE
	li 	$5, BIOSPANIC # put here panic() address
	li 	$6, VECTAREANUM
Lfor:	
	sw	$5, VECTPCPOS($4)
	addiu	$4, VECTSIZE
	addi	$6, -1
	bgtz	$6, Lfor
	
	# at kernel CONTEXT offset into BIOS page, there is the TLB entry
	# for kernel page table, and the starting address into that page:
	# we set CONTEXT = 0x500 (1280), virtual page 0xC0001000
	# page frame at 0x20001000, kernel ASID = 0, G bit = 1
 	# starting address 0xC0001000 (0 offset into page)
 
	li 	$4, (BIOSVECTPAGE + KCONTEXTOFFS)
	li	$5, KPTABVPAGE
	li	$6, (KPTABFRAME | DVGPERMISSION)
	sw	$5, 0($4)
	sw	$6, 4($4)
	sw	$5, 8($4)

	# just to start the kernel without too many EXC, it loads the first
	# kernel entry into TLB: to do this, it have to load the page table
	# entry into TLB too
	mtc0	$5, $10
	mtc0	$6, $2  
	
	.set noreorder
	.set nomacro
	nop
	tlbwr
	nop
	.set reorder
	.set macro
	
	# now loads the first entry
	move	$4, $5
	lw	$5, 0($4)
	lw	$6, 4($4)
	mtc0    $5, $10
	mtc0    $6, $2
	
	.set noreorder
	.set nomacro
	nop
	tlbwr
	nop
	.set reorder
	.set macro
	
	# finally, we set CONTEXT field, ASID and STATUS for kernel:
	# being ASID = 0, and STATUS good as it is now,
	# just load CONTEXT
	li	$5, (KCONTEXTOFFS << CONTEXTSTART)
	mtc0	$5, $4
	
	# and now let's start kernel: its starting address is 
	# in aout place for it
	li	$4, PROGVSTART
	lw	$31, 0($4)

	.set noreorder
	.set nomacro
	jr	$31
	rfe
	.set reorder
	.set macro	
	
	.end tapeboot

LtapebootEnd:
	.size	 tapeboot, LtapebootEnd - tapeboot
